﻿ abr2←x Linear y;ab;r2;yt
⍝ FIND THE COEFFICIENTS(a,b) OF A LINEAR REGRESSION
⍝ Y' = a + b×X

 abr2←0 0 0

 :If 2>⍴∪x
     ∆CRLF,'1. LINEAR:          Not Enough Independant Points for a Regression' ⋄ →0
 :End

 :Trap 0
     ab←y⌹x∘.*0 1
     yt←ab YTLinear x
     r2←1-(+/(y-yt)*2)÷+/(y-(+/y)÷⍴y)*2
     abr2←ab,r2

     '1. LINEAR:          Y'' = ',(⍕abr2[1]),' + ',(⍕abr2[2]),'×X   (r² = ',(DEB 3⍕abr2[3]),')'
 :Else
     ∆CRLF,'1. LINEAR:          Regression not possible' ⋄ →0
 :EndTrap